Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 21336

Description

Here is a list of issues/regressions with the node tool in master:

    -  deleting a node: the rubber band is not removed

    -  deleting a node: when finished, the next node should be pre-selected (this pre-selection should by synchro with the table view

selection model).

    -  pre-selection allows modifying coordinates in the table (keeps the same pre selection) or deleting the node (next node is then

pre-selected)

    -  we can use < > in the pre-selection to browse nodes

    -  multiple nodes can be pre-selected (so they can be deleted at once)

    -  right-click should cancel the edition of the node (but keeps it pre-selected)

    -  right now, table view does not allow deletion (it should)

    -  for point layers, there is no visual feedback of the point being moved (no rubberband)

    -  cannot remove parts and rings or full geometries by removing all vertices (see #13099)

    -  editing in table view: changes should be applied to the rubberband on keypress (not on editing finished), and when editing is finished

it should ends the digitizing (clear rubberband)

Related issues:

Related to QGIS Application - Bug report # 13099: [regression] nodetool canno... Closed 2015-07-09

Related to QGIS Application - Bug report # 13257: right click should cancel t... Closed 2015-08-24

Related to QGIS Application - Bug report # 13275: rubberband when using node ... Closed 2015-08-27

Related to QGIS Application - Bug report # 13393: Bad work with "Node tool" Closed 2015-09-22

Related to QGIS Application - Bug report # 13635: different handling of inval... Closed 2015-10-20

Duplicated by QGIS Application - Bug report # 13348: Node tool - multi selection Closed 2015-09-12

History

#1 - 2015-08-27 07:26 AM - Denis Rouzaud

- snapping doesn't work properly with node tool

#2 - 2015-08-27 07:27 AM - Denis Rouzaud

for snapping, it's mainly the visual feedback which is missing

#3 - 2015-08-29 02:12 AM - Paul Kanelli

- Assignee deleted (Marco Hugentobler)
Please go to Settings/Snapping options and disable topological editing.

'for snapping, it's mainly the visual feedback which is missing'

Unfortunately some QGIS tools don't support visual feeedback for snapping.

#4 - 2015-08-29 02:17 AM - Nathan Woodrow

- Assignee set to Marco Hugentobler

Paul please don't unassign people from tickets. They can do it themselves

#5 - 2015-08-29 04:04 AM - Paul Kanelli

My fault, I accidentally did this.

#6 - 2015-09-07 02:22 AM - Nyall Dawson

- Priority changed from High to Severe/Regression

Another regression is that the node tool can't be used to remove a ring anymore... before you could progressively remove nodes until the whole ring was

removed

#7 - 2015-09-07 02:23 AM - Nyall Dawson

Actually, that last point is a dupe of #13099. Sorry for the noise!

#8 - 2015-09-07 02:37 AM - Marco Hugentobler

- Status changed from Open to Feedback

- can't delete a node anymore, right?

Is this still true? I can remove features with the node tool. Or do you mean that you cannot remove point features with the node tool?

- when editing lines, if two lines share a node, we can't move the node from one of them

Cannot reproduce that. Is it still valid? If yes, I need more information

#9 - 2015-09-07 06:25 AM - Denis Rouzaud

- Status changed from Feedback to Open

deleting nodes: it should not delete the feature but rather empty the geometry.

with lines: you can end up having only one node, without being able to delete the last one (got a crash at trying to delete the last one) => invalid geometry
also it's not very convenient to delete nodes:

- it would be nice to be able to delete them from a row selected in the table view

- the behavior on the screen is weird when pressing delete: you still have to mouse press and it ends up in a weird new placement. I would say that

pressing delete deletes the node and ends up the digitizing action.

the problem of a node being shared is still present: you can't edit the node of one of the 2 lines

see https://youtu.be/WZ7rUb7eRdg

I would recommend to urge a bit fixing these issues in the node tool. It makes editing pretty unusable right now in master, and we're getting closer to the

release. I would say we need quite of testing on this.

#10 - 2015-09-07 03:08 PM - Nyall Dawson

I'm seeing this behavior with deleting nodes in a polygon:

- select a node, press delete

- QGIS starts MOVING the next node, and it's automatically relocated to the mouse position. move the mouse a bit and things go crazy with the

rubberband.

The correct (2.8) behavior is that deleting a node just selects the next node, and doesn't automatically start moving it.

Another issue is:

- Select a node with left click, QGIS starts moving it

- Try to select the next node using > or < , the selected node changes but not for the rubberband - things go crazy

#11 - 2015-09-07 10:15 PM - Denis Rouzaud

- Select a node with left click, QGIS starts moving it

This is the intended new behavior to allow advanced digitizing to be used with the node tool.

#12 - 2015-09-08 12:23 AM - Nyall Dawson

That's not the issue though - the issue is the rubberband doesn't cope with navigating through points using > and <

#13 - 2015-09-10 01:18 AM - Denis Rouzaud

I'll try to make the point, as of today's master

    -  deleting a node: the rubber band is not removed

    -  deleting a node: when finished, the next node should be pre-selected (this pre-selection should by synchro with the table view selection model).

    -  pre-selection allows modifying coordinates in the table (keeps the same pre selection) or deleting the node (next node is then pre-selected)

    -  we can use < > in the pre-selection to browse nodes

    -  multiple nodes can be pre-selected (so they can be deleted at once)

    -  right-click should cancel the edition of the node (but keeps it pre-selected)

    -  right now, table view does not allow deletion (it should)

    -  for point layers, there is no visual feedback of the point being moved (no rubberband)

    -  cannot remove parts and rings or full geometries by removing all vertices (see #13099)
    -  editing in table view: changes should be applied to the rubberband on keypress (not on editing finished), and when editing is finished it should ends the

digitizing (clear rubberband)

#14 - 2015-09-11 04:46 AM - Marco Hugentobler

deleting a node: when finished, the next node should be pre-selected (this pre-selection should by synchro with the table view selection model).

pre-selection allows modifying coordinates in the table (keeps the same pre selection) or deleting the node (next node is then pre-selected)

What is 'pre-selected'? Is it a third state between not-selected and selected where the node is selected but the rubberband not moved?

#15 - 2015-09-11 04:54 AM - Denis Rouzaud

The idea of the pre-selection is that the node is selected but doesn't follow the mouse.

In such state, you can:

    -  delete it

    -  move it by entering coordinates in the table view

The pre-selection of a node is triggered by:

    -  the selection of its corresponding row in the table view

    -  the end of a digitizing action (moving/deleting/inserting a node, in the case of deleting next available node is pre-selected)

Does it make sense to you?

#16 - 2015-09-11 05:27 AM - Nyall Dawson

The pre-selection of a node is triggered by:

the selection of its corresponding row in the table view

the end of a digitizing action (moving/deleting/inserting a node, in the case of deleting next available node is pre-selected)

Also by navigating through nodes using < and >

#17 - 2015-09-11 05:33 AM - Denis Rouzaud

I would rephrase to:

you can navigate in the pre-selection (i.e. browse nodes) by:

    -  selecting a row in the table view

    -  pressing < or > to go to previous/next node

#18 - 2015-09-11 07:44 AM - Marco Hugentobler

The idea of the pre-selection is that the node is selected but doesn't follow the mouse.

In such state, you can:

Ok, I understand. It is hard to tell how usable it will be before having it implemented. It needs quite a bit of changes in the node tool class (and tomorrow, I'm

going to the FOSS4G conference...).
#19 - 2015-09-13 10:16 PM - Denis Rouzaud

Also, pre-selection should allow multiple nodes selection to allow their deletion at once (otherwise, we have a regression).

#20 - 2015-09-13 11:13 PM - Denis Rouzaud

- Subject changed from other node tool problems to node tool regressions and issues

#21 - 2015-09-14 01:49 AM - Nyall Dawson

Also, pre-selection should allow multiple nodes selection to allow their deletion at once (otherwise, we have a regression).

I believe it was also possible to move multiple nodes at once in 2.8. Not sure how that can be translated to the click click model, but let's add that to the fix

list too...

#22 - 2015-09-14 01:55 AM - Denis Rouzaud

I believe it was also possible to move multiple nodes at once in 2.8. Not sure how that can be translated to the click click model, but let's add that to

the fix list too...

This is not straightforward in the click-click mode.

An idea could be to use the space bar to free pre-selected node(s).

#23 - 2015-09-14 02:48 AM - Mathieu Pellerin - nIRV

Nyall Dawson wrote:

Also, pre-selection should allow multiple nodes selection to allow their deletion at once (otherwise, we have a regression).

I believe it was also possible to move multiple nodes at once in 2.8. Not sure how that can be translated to the click click model, but let's add that to

the fix list too...

Absolutely, one could (quite conveniently) move a set of nodes at once. It was working like this:

- drag over a set of nodes to make your selection

- click and hold the mouse's left button on one of the selected nodes and drag

That would move a group of selected nodes, and the node through which your moving the group would respect snapping settings too.

#24 - 2015-09-14 03:11 AM - Nyall Dawson

Honestly... given the timing involved, huge number of regressions, and lack of developer presence, is it worth postponing the move to click-click to 2.14?

#25 - 2015-09-29 12:03 AM - Marco Hugentobler

- Status changed from Open to Closed
click-click is reverted.
